#!/bin/sh
#$1 install or unistall 
SERVICENAME="JgPPDConfig"

install_files()
{
    cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/pdftojgpdf       /usr/lib/cups/filter/
    cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/rastertojg       /usr/lib/cups/filter/
    #cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/JgPPDConfig      /etc/init.d/JgPPDConfig
    cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/zcusb            /usr/lib/cups/backend/
    cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/*.rules          /lib/udev/rules.d/
    cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/JgPnP            /lib/udev/
    cp -vf /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/*.ppd           /usr/share/cups/model/

    chmod 755 /usr/lib/cups/filter/rastertojg
    chmod 755 /usr/lib/cups/filter/pdftojgpdf
    chmod 755 /usr/lib/cups/backend/zcusb


    tar -xzvf  /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/jre1.8.0_111.tar.gz -C /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/   

    mkdir -p  /var/log/JaguarLog/
    chmod 777 /var/log/JaguarLog/
    mkdir -p /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/config
    chmod 777 /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/config

    #if [ -f /usr/lib/libtinyxml.so.2.6.2 ]
    if [ -f /usr/lib/x86_64-linux-gnu/libtinyxml.so.2.6.2 ]
    then
        echo "libtinyxml Library File Exists"
    else
        cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/libtinyxml.so.2.6.2 /usr/lib/x86_64-linux-gnu/libtinyxml.so.2.6.2
        echo "libtinyxml Library File Copied"
    fi
    
    #Always overwrite zmj library file
    #if [ -f /usr/lib/libzmjxml.so ]
    #then
    #    echo "libzmjxml Library File Exists"
    #else
        cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/libzmjxml.so /usr/lib
        echo "libzmjxml Library File Copied"
    #fi

       

   cp -f /etc/profile $DSTDIR/profile
   echo "xhost +" >> /etc/profile
   . /etc/profile

   echo 'Installation Completed for' $flag
   if [ $flag = "RHEL" ] 
   then
    echo 'To Do'
    #cp /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/zxps3printerproperties.console /etc/security/console.apps/ZXP7PrinterProperties
    #cp /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/zxps3printerproperties.pam /etc/pam.d/zxps7PrinterProperties
    #ln -fs /usr/bin/consolehelper /usr/bin/zxps3printerproperties
   else
    echo 'Ubuntu PKEXEC'
    cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/com.zebra.jaguar.pkexec.policy /usr/share/polkit-1/actions/
    chmod 644 /usr/share/polkit-1/actions/com.zebra.jaguar.pkexec.policy 
    cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/ZebraZCSeries.desktop /usr/share/applications/

    cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/com.zebra.jaguar.uninst.pkexec.policy /usr/share/polkit-1/actions/
    chmod 644 /usr/share/polkit-1/actions/com.zebra.jaguar.uninst.pkexec.policy
    cp -v /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/ZebraZCSeriesUninstall.desktop /usr/share/applications/
   fi
   updateUdev
   /etc/init.d/cups restart
   udevadm control --reload-rules
   service cups restart
   echo "Installation Completed"
   return
}

installservice()
{
uninstallservice
echo "--- Installation ---"
update-rc.d "$SERVICENAME" defaults
service "$SERVICENAME" start
}

uninstallservice()
{
echo "--- UnInstallation ---"
service "$SERVICENAME" stop
update-rc.d -f "$SERVICENAME" remove
}
updateUdev()
{
CPY=false
if [ -f /usr/lib/libudev.so.1 ]
then 
   echo "libudev.so.1 is present"
   CPY=true
else
   echo "libudev.so.1 is not present"
   #CPY=false
fi

if [ -f /lib/x86_64-linux-gnu/libudev.so.1 ]
then
   echo "libudev.so.1 is present"
    CPY=true
else
   echo "libudev.so.1 is not present"
    #CPY=false
fi

if [ -f /lib/i386-linux-gnu/libudev.so.1 ]
then
   echo "libudev.so.1 is present"
    CPY=true
else
   echo "libudev.so.1 is not present"
    #CPY=false
fi

MACH=$(uname -m)
if [ $MACH = "i686" ]; then
 echo "32 Bit System"
 ARCH="32Bit"
else
 echo "64 Bit System"
  ARCH="64Bit"
fi

if [ $CPY = false ]
then
    if [ $ARCH = "64Bit" ];then
        cp /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/libudev_64bit.so.1 /usr/lib/libudev.so.1
        echo "64Bit Copy"
    else
        cp /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/libudev_32bit.so.1 /usr/lib/libudev.so.1
        echo "32Bit Copy"
    fi
fi
 

}

disable_enforce()
{
    #echo "###Modified By Zebra Printers###" > /etc/selinux/config
    echo "SELINUX=disabled" > /etc/selinux/config
    echo  "SELINUXTYPE=targeted" >> /etc/selinux/config
    echo   "SETLOCALDEFS=0" >> /etc/selinux/config
    setenforce 0
    echo 0 > /selinux/enforce
  return;
}

uninstall_files()
{
   echo 'Deleting Printers'
   /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/JgRemovePrinter
   echo 'Deleting Printers Successful'
   /etc/init.d/cups restart
   uninstallservice
   rm -rf /etc/init.d/JgPPDConfig
   cp -vf /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/profile /etc/profile
   #rm -f /usr/share/applications/Zebra_ZXP7_Series_Printer_Driver-program.desktop
   #rm -f /usr/share/applications/Zebra_ZXP7_Series_Printer_Driver-uninstall.desktop
   #rm -f /usr/share/applications/Zebra_ZXP7_Series_Card_Printer_Driver-program.desktop
   #rm -f /usr/share/applications/Zebra_ZXP7_Series_Card_Printer_Driver-uninstall.desktop
   rm -vf /usr/lib/cups/filter/pdftojgpdf
   rm -vf /usr/lib/cups/filter/rastertojg
   rm -vf /usr/lib/cups/backend/zcusb
   rm -vrf /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver/jar
   rm -rv /usr/share/cups/model/ZebraZC*.ppd

   mv -vf /etc/cups/cupsd.default.zxp7 /etc/cups/cupsd.conf
   #rm -v /usr/share/applications/zebrazxp7.desktop 
   #rm -v /usr/share/applications/zebrazxp7uninstall.desktop
   rm -rf /etc/udev/rules.d/10-ZebraJaguar.rules
   rm -v /usr/share/applications/ZebraZCSeries.desktop 
   rm -v /usr/share/applications/ZebraZCSeriesUninstall.desktop
   rm -rf /lib/udev/jgpnp
   rm -rf  /usr/lib/libzmjxml.so
   #rm -rf /usr/share/polkit-1/actions/com.zebra.jaguar.pkexec.policy
    #rm -rf /usr/bin/jaguar-pkexec
  
    #rm -rf /usr/share/polkit-1/actions/com.zebra.jaguar.uninst.pkexec.policy
    #rm -rf /usr/bin/jaguar-uninst-pkexec
   rm -vrf /opt/apps/com.zebra.jaguardriver/files/ZebraJaguarDriver
   remove_ppd_files
   udevadm control --reload-rules
  /etc/init.d/cups restart
   echo 'Uninstallation Completed'
 
 return

}




remove_ppd_files()
{
	rm -rf /usr/share/cups/model/ZebraZC*.ppd
}

###
# Main body of script starts here
###


isMac=$(uname)

 if [ $isMac = "Darwin" ]
  then
   echo "This is MacBook"
   install_uninstall_mac_files
   exit
 fi

 if [ -f /etc/redhat-release ]
  then 
   echo "Redhat or Fedora Version"
   IsRedHat="yes"
  else
   echo "Ubuntu System"
   IsRedHat="no"
  fi
 
#Find Linux Version / Flavour

 if [ $IsRedHat = "yes" ]
  then
   echo "RHEL or Fedora System"

   disable_enforce
   version=$(cat /etc/redhat-release | sed -e 's/[^0-9]//g;s/^$/-1/')
   #RHEL Version 6.1, 6.2, 6.3, 6.4, 6.5, 6.6
   if [ $version == 61 -o $version == 62 -o $version == 63 -o $version == 64 -o $version == 65 -o $version == 66 ]
    then
     flag="RHEL" 
    else
     flag="Fedora"
   fi        
 else
   echo "This is Ubuntu System"
   flag="Ubuntu"
 fi

 if [ $1 = "install" ]
  then
   echo "installing files"
   install_files
   ###installservice
 else
   echo "Uninstalling files"
   uninstall_files
 fi
